%global displaylink_release 59.184
# % global beta 0
%global version_base 5.6.1
%global _hardened_build 1
%global evdi_version 1.11.0

Name:               displaylink
Version:            %{version_base}
Release:            1%{?beta:.beta}%{?dist}
Summary:            Metapackage for proprietary DisplayLink Manager application
URL:                https://www.synaptics.com/products/displaylink-graphics/downloads/ubuntu
# The DisplayLink proprietary software can be obtained using:
# curl -LO https://www.synaptics.com/sites/default/files/exe_files/2021-04/DisplayLink%20USB%20Graphics%20Software%20for%20Ubuntu5.4-EXE.zip
Source0:            DisplayLink USB Graphics Software for Ubuntu%{?beta: (Beta)}%{version_base}%{?beta: Beta}-EXE.zip

Source1:            displaylink.service
Source2:            99-displaylink.rules
Source3:            displaylink-sleep-extractor.sh
Source5:            20-displaylink.conf
Source6:            95-displaylink.preset
Source7:            %{name}.logrotate

License:            MIT
Requires:           akmod-evdi, %{name}-config, %{name}-manager
BuildRequires:      systemd-rpm-macros
BuildRequires:      systemd

%description
Metapackage to install akmod and proprietary tools needed to communicate with and manage
DisplayLink USB graphics adapters along with additional config files.

%files


%package manager
Summary:            Proprietary DisplayLink Manager application
License:            Redistributable, no modification permitted
URL:                https://www.synaptics.com/products/displaylink-graphics/downloads/ubuntu
ExclusiveArch:      armv7hl i386 x86_64
BuildRequires:      libdrm-devel
# The DisplayLinkManager binary is linked at run-time to a specific version of libevdi
Requires:           libevdi => %{evdi_version}
Requires:           libusbx

%description manager
This contains the proprietary tools needed to communicate with and manage
DisplayLink USB graphics adapters.

%files manager
%license displaylink-%{version}/displaylink-driver-%{version}-%{displaylink_release}/LICENSE
%dir %{_libexecdir}/%{name}
%{_libexecdir}/%{name}/DisplayLinkManager
%{_libexecdir}/%{name}/ella-dock-release.spkg
%{_libexecdir}/%{name}/firefly-monitor-release.spkg
%{_libexecdir}/%{name}/ridge-dock-release.spkg
%dir /var/log/%{name}/
%{_prefix}/lib/systemd/system-sleep/displaylink.sh

%package config
Summary:            Supporting config files for DisplayLink USB graphics adapters
License:            MIT
URL:                https://github.com/displaylink-rpm/displaylink-rpm
BuildArch:          noarch
Requires:           %{name}-manager

%description config
This adds support for HDMI/VGA adapters built upon the DisplayLink DL-6xxx,
DL-5xxx, DL-41xx and DL-3xxx series of chipsets. This includes numerous
docking stations, USB monitors, and USB adapters.

%preun config
%systemd_preun displaylink.service

%postun config
%systemd_postun_with_restart displaylink.service

%files config
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_unitdir}/displaylink.service
%{_udevrulesdir}/99-displaylink.rules
%{_datadir}/X11/xorg.conf.d/20-displaylink.conf
%{_presetdir}/95-displaylink.preset

%post config
%systemd_post displaylink-service



%prep
rm -rf displaylink-%{version}
mkdir displaylink-%{version}
cd displaylink-%{version}
unzip -o "%{SOURCE0}"
chmod +x displaylink-driver-%{version}-%{?beta:beta-}%{displaylink_release}.run
./displaylink-driver-%{version}-%{?beta:beta-}%{displaylink_release}.run --noexec --keep
# This creates a displaylink-driver-$version subdirectory

%install
mkdir -p %{buildroot}%{_libexecdir}/%{name}/
mkdir -p %{buildroot}%{_unitdir}/
mkdir -p %{buildroot}%{_presetdir}/
mkdir -p %{buildroot}%{_prefix}/lib/systemd/system-sleep/
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
mkdir -p %{buildroot}%{_udevrulesdir}/
mkdir -p %{buildroot}%{_datadir}/X11/xorg.conf.d/
mkdir -p %{buildroot}%{_localstatedir}/log/%{name}/

cd displaylink-%{version}

export QA_RPATHS=0x0004

# DisplayLinkManager
pushd displaylink-driver-%{version}-%{displaylink_release}

%ifarch x86_64
cp -a x64-ubuntu-1604/DisplayLinkManager %{buildroot}%{_libexecdir}/%{name}/
%endif

%ifarch %ix86
cp -a x86-ubuntu-1604/DisplayLinkManager %{buildroot}%{_libexecdir}/%{name}/
%endif

%ifarch armv7hl
cp -a arm-linux-gnueabihf/DisplayLinkManager %{buildroot}%{_libexecdir}/%{name}/
%endif

# Firmwares
cp -a ella-dock-release.spkg firefly-monitor-release.spkg ridge-dock-release.spkg %{buildroot}%{_libexecdir}/%{name}/

# pm-util
bash %{SOURCE1} displaylink-installer.sh > %{buildroot}%{_prefix}/lib/systemd/system-sleep/displaylink.sh


chmod +x %{buildroot}%{_prefix}/lib/systemd/system-sleep/displaylink.sh

popd

# systemd/udev
install -m 644 %{SOURCE1} %{buildroot}%{_unitdir}
install -m 644 %{SOURCE7} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -m 644 %{SOURCE6} %{buildroot}%{_presetdir}
install -m 644 %{SOURCE2} %{buildroot}%{_udevrulesdir}
install -m 644 %{SOURCE5} %{buildroot}%{_datadir}/X11/xorg.conf.d

%changelog
* Thu Apr 08 2021 ffgiff <ffgiff@gmail.com> 5.4-1
- First version
